VERSION 5.00
Begin VB.UserControl DataController 
   AutoRedraw      =   -1  'True
   BackStyle       =   0  'Transparent
   CanGetFocus     =   0   'False
   ClientHeight    =   510
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   555
   InvisibleAtRuntime=   -1  'True
   MaskColor       =   &H00FF00FF&
   MaskPicture     =   "DataController.ctx":0000
   Picture         =   "DataController.ctx":09E2
   ScaleHeight     =   510
   ScaleWidth      =   555
   ToolboxBitmap   =   "DataController.ctx":13C4
End
Attribute VB_Name = "DataController"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'DataController ver. 2.0

'Created by:   Douglas Cavan

Option Explicit

'Private Variables
Private WithEvents mParent As Form           'needed to receive unload event of parent
Attribute mParent.VB_VarHelpID = -1
                                             'one reason why this object can't be use in vb.net
Private cBoundControl      As New Collection
Private cDataField         As New Collection
Private cRequired          As New Collection
Private cLockOnEdit        As New Collection
Private cFrameControl      As New Collection
Private cFraLockOnEdit     As New Collection
Private cExtraControl      As New Collection
Private cExLockOnEdit      As New Collection
Private mAddMode           As Boolean
Private mEditMode          As Boolean

'Default Property Values:
Const m_def_BackColorReadOnly = &H80000005
Const m_def_BackColorEditMode = &H80000005

'Property Variables:
Dim m_BackColorReadOnly    As OLE_COLOR
Dim m_BackColorEditMode    As OLE_COLOR
Dim m_RecordSet            As ADODB.RecordSet

'Event Declarations:
Event AfterAdd()
Event AfterDelete()
Event AfterEdit()
Event BeforeAdd()
Event BeforeEdit()
Event MoveComplete()
Event AfterCancelUpdate()
Event BeforeCancelUpdate(Cancel As Integer)

Public Property Get AddMode() As Boolean
   
   AddMode = mAddMode

End Property

Public Property Get EditMode() As Boolean
   
   EditMode = mEditMode

End Property

Private Sub mParent_Unload(Cancel As Integer)

   On Error Resume Next
   If mAddMode Or mEditMode Then
      If MsgBox("You have pending operations! Do you really want to close" & _
         vbCrLf & "this form without saving this record?", vbInformation + vbYesNo, _
         "Pending Operation") = vbNo Then
         Cancel = 1
         Exit Sub
      End If
   End If
   m_RecordSet.CancelUpdate
   m_RecordSet.Close

   Set m_RecordSet = Nothing

End Sub

Private Sub UserControl_Resize()

   On Error Resume Next
   With UserControl
      .Width = 435
      .Height = 435
   End With

End Sub

Public Property Get RecordSet() As ADODB.RecordSet

   Set RecordSet = m_RecordSet

End Property

Public Property Set RecordSet(ByVal New_RecordSet As ADODB.RecordSet)

   Set m_RecordSet = New_RecordSet

   PropertyChanged "RecordSet"

End Property

Private Sub UserControl_InitProperties()

   m_BackColorReadOnly = m_def_BackColorReadOnly
   m_BackColorEditMode = m_def_BackColorEditMode

End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

   On Error Resume Next

   Set mParent = Extender.Parent
   Set m_RecordSet = PropBag.ReadProperty("RecordSet", Nothing)

   m_BackColorReadOnly = PropBag.ReadProperty("BackColorReadOnly", m_def_BackColorReadOnly)
   m_BackColorEditMode = PropBag.ReadProperty("BackColorEditMode", m_def_BackColorEditMode)

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

   Call PropBag.WriteProperty("RecordSet", m_RecordSet, Nothing)
   Call PropBag.WriteProperty("BackColorReadOnly", m_BackColorReadOnly, m_def_BackColorReadOnly)
   Call PropBag.WriteProperty("BackColorEditMode", m_BackColorEditMode, m_def_BackColorEditMode)

End Sub

Public Sub CancelUpdate(Optional ByVal RaiseMoveComplete As Boolean = True)
   Dim iCancel As Integer
   
   RaiseEvent BeforeCancelUpdate(iCancel)
   
   If iCancel = 1 Then Exit Sub
   
   On Error Resume Next

   With m_RecordSet
      .CancelUpdate
      mAddMode = False
      mEditMode = False
      If .RecordCount = 0 Then

         Call ClearControlEx
         Call LockControlEx(True)

      Else

         Call BindDataToControl
         Call LockControlEx(True)

      End If
   End With
   RaiseEvent AfterCancelUpdate
   If RaiseMoveComplete Then
      RaiseEvent MoveComplete
   End If

End Sub

Public Function UpdateRec(Optional ByVal ShowPrompt As Boolean = True) As Boolean

   On Error GoTo DTErr
   If ShowPrompt Then
      If MsgBox("Do you really want to save this record?", vbQuestion + vbYesNo, "Save Record?") = vbYes Then
         Screen.MousePointer = vbArrowHourglass
         DoEvents
         If IsRequiredFilled Then      'Check if all required field are being filled
            If BindControlToData Then
               m_RecordSet.Update
            Else
               UpdateRec = False
               Screen.MousePointer = vbDefault
               Exit Function
            End If
         Else
            UpdateRec = False
            Screen.MousePointer = vbDefault
            Exit Function
         End If

         Call LockControlEx(True)

         If mAddMode Then
            RaiseEvent AfterAdd
         ElseIf mEditMode Then
            RaiseEvent AfterEdit
         End If
         mAddMode = False
         mEditMode = False
         UpdateRec = True
         Screen.MousePointer = vbDefault
         DoEvents
      Else
         UpdateRec = False
      End If
      Screen.MousePointer = vbDefault
      Exit Function
   Else
      Screen.MousePointer = vbArrowHourglass
      DoEvents
      If IsRequiredFilled Then
         If BindControlToData Then
            m_RecordSet.Update
         Else
            UpdateRec = False
            Screen.MousePointer = vbDefault
            Exit Function
         End If
      Else
         UpdateRec = False
         Screen.MousePointer = vbDefault
         Exit Function
      End If

      Call LockControlEx(True)

      If mAddMode Then
         RaiseEvent AfterAdd
      ElseIf mEditMode Then
         RaiseEvent AfterEdit
      End If
      mAddMode = False
      mEditMode = False
      UpdateRec = True
      Screen.MousePointer = vbDefault
      DoEvents
   End If
   Screen.MousePointer = vbDefault
   Exit Function
DTErr:
   UpdateRec = False
   If Err.Number = -2147217887 Then
      MsgBox "You have entered an invalid value for this record! Please validate data entry." _
         , vbExclamation, "Data Type Mismatch Error"
   Else
      MsgBox Err.Description & vbCrLf & vbCrLf & _
         "If problem persist, please contact Technical Support for more information." _
         , vbCritical, Extender.Parent.Caption
   End If
   Screen.MousePointer = vbDefault

End Function

'Call this function to delete currently positioned record
Public Function DeleteCurrentRec(Optional ByVal ShowPrompt As Boolean = True, _
                                 Optional ByVal RaiseMoveComplete As Boolean = True) As Boolean

   On Error GoTo DelErr
   If ShowPrompt Then
      If MsgBox("Are you sure you want to delete this record?" & vbCrLf & _
               "Hint: Deleted records cannot be undeleted, unless you re-encode those records" _
               , vbExclamation + vbYesNo, "Delete this Record?") = vbYes Then
         Screen.MousePointer = vbArrowHourglass
         With m_RecordSet
            If .RecordCount = 0 Then Screen.MousePointer = vbDefault: Exit Function
            .Delete adAffectCurrent
            DeleteCurrentRec = True
            RaiseEvent AfterDelete
            If .RecordCount = 0 Then
               ClearControlEx
               Screen.MousePointer = vbDefault
               If RaiseMoveComplete Then RaiseEvent MoveComplete
               Exit Function
            End If
            .MoveNext
            If .EOF Then
               MoveLast
            Else
               BindDataToControl
               LockControlEx True
               If RaiseMoveComplete Then RaiseEvent MoveComplete
            End If
         End With
         Screen.MousePointer = vbDefault
      Else
         DeleteCurrentRec = False
      End If
   Else
      Screen.MousePointer = vbArrowHourglass
      With m_RecordSet
         If .RecordCount = 0 Then Screen.MousePointer = vbDefault: Exit Function
         .Delete adAffectCurrent
         DeleteCurrentRec = True
         RaiseEvent AfterDelete
         If .RecordCount = 0 Then
            ClearControlEx
            Screen.MousePointer = vbDefault
            If RaiseMoveComplete Then RaiseEvent MoveComplete
            Exit Function
         End If
         .MoveNext
         If .EOF Then
            MoveLast
         Else
            BindDataToControl
            LockControlEx True
            If RaiseMoveComplete Then RaiseEvent MoveComplete
         End If
      End With
      Screen.MousePointer = vbDefault
   End If
   Screen.MousePointer = vbDefault
   Exit Function
DelErr:
   DeleteCurrentRec = False
   MsgBox Err.Description, vbExclamation, Extender.Parent.Caption
   Screen.MousePointer = vbDefault

End Function

'Call this function if you want delete record not in current position
Public Function DeleteRec(ByVal FieldToDel, ByVal StrToDel, _
                          Optional ByVal FieldToDel1, Optional ByVal StrToDel1, _
                          Optional ByVal FieldToDel2, Optional ByVal StrToDel2, _
                          Optional ByVal ShowPrompt As Boolean = True) As Boolean

   On Error GoTo DelErr
   If ShowPrompt Then
      If MsgBox("Are you sure you want to delete this record?" & vbCrLf & _
               "Hint: Deleted records cannot be undeleted, unless you re-encode those records" _
               , vbExclamation + vbYesNo, "Delete this Record?") = vbYes Then
         Screen.MousePointer = vbArrowHourglass
         With m_RecordSet
            If .RecordCount = 0 Then Screen.MousePointer = vbDefault: Exit Function
            If FindRecord(FieldToDel, StrToDel, FieldToDel1, _
               StrToDel1, FieldToDel2, StrToDel2, False, False) Then       'locate record using FindRecord Function
               .Delete adAffectCurrent
               DeleteRec = True
               RaiseEvent AfterDelete
               If .RecordCount = 0 Then ClearControlEx: Screen.MousePointer = vbDefault: Exit Function
               .MoveNext
               If .EOF Then
                  MoveLast
               Else
                  BindDataToControl
                  LockControlEx True
               End If
            End If
         End With
         Screen.MousePointer = vbDefault
      Else
         DeleteRec = False
      End If
   Else
      Screen.MousePointer = vbArrowHourglass
      With m_RecordSet
         If .RecordCount = 0 Then Screen.MousePointer = vbDefault: Exit Function
         If FindRecord(FieldToDel, StrToDel, FieldToDel1, _
            StrToDel1, FieldToDel2, StrToDel2, False, False) Then
            .Delete adAffectCurrent
            DeleteRec = True
            RaiseEvent AfterDelete
            If .RecordCount = 0 Then ClearControlEx: Screen.MousePointer = vbDefault: Exit Function
            .MoveNext
            If .EOF Then
               MoveLast
            Else
               BindDataToControl
               LockControlEx True
            End If
         End If
      End With
      Screen.MousePointer = vbDefault
   End If
   Screen.MousePointer = vbDefault
   Exit Function
DelErr:
   DeleteRec = False
   MsgBox Err.Description & vbCrLf & vbCrLf & _
      "If problem persist, please contact Technical Support for more information." _
      , vbExclamation, Extender.Parent.Caption
   Screen.MousePointer = vbDefault

End Function

Public Sub MoveFirst()

   On Error GoTo RecMoveErr
   Screen.MousePointer = vbArrowHourglass
   With m_RecordSet
      If Not .RecordCount = 0 Then
         .MoveFirst

         Call BindDataToControl
         Call LockControlEx(True)

      Else

         Call ClearControlEx
         Call LockControlEx(True)

      End If
   End With
   RaiseEvent MoveComplete
   Screen.MousePointer = vbDefault
   Exit Sub
RecMoveErr:
   MsgBox Err.Description, vbExclamation, Extender.Parent.Caption
   Screen.MousePointer = vbDefault

End Sub

Public Sub MovePrevious()

   On Error GoTo RecMoveErr
   Screen.MousePointer = vbArrowHourglass
   With m_RecordSet
      If Not .RecordCount = 0 Then
         If (.AbsolutePosition = 1) Or .BOF Then
            .MoveFirst
         Else
            .MovePrevious
         End If

         Call BindDataToControl
         Call LockControlEx(True)

      Else

         Call ClearControlEx
         Call LockControlEx(True)

      End If
   End With
   RaiseEvent MoveComplete
   Screen.MousePointer = vbDefault
   Exit Sub
RecMoveErr:
   MsgBox Err.Description, vbExclamation, Extender.Parent.Caption
   Screen.MousePointer = vbDefault

End Sub

Public Sub MoveNext()

   On Error GoTo RecMoveErr
   Screen.MousePointer = vbArrowHourglass
   With m_RecordSet
      If Not .RecordCount = 0 Then
         If (.AbsolutePosition = .RecordCount) Or .EOF Then
            .MoveLast
         Else
            .MoveNext
         End If

         Call BindDataToControl
         Call LockControlEx(True)

      Else

         Call ClearControlEx
         Call LockControlEx(True)

      End If
   End With
   RaiseEvent MoveComplete
   Screen.MousePointer = vbDefault
   Exit Sub
RecMoveErr:
   MsgBox Err.Description, vbExclamation, Extender.Parent.Caption
   Screen.MousePointer = vbDefault

End Sub

Public Sub MoveLast()

   On Error GoTo RecMoveErr
   Screen.MousePointer = vbArrowHourglass
   With m_RecordSet
      If Not .RecordCount = 0 Then
         .MoveLast

         Call BindDataToControl
         Call LockControlEx(True)

      Else

         Call ClearControlEx
         Call LockControlEx(True)

      End If
   End With
   RaiseEvent MoveComplete
   Screen.MousePointer = vbDefault
   Exit Sub
RecMoveErr:
   MsgBox Err.Description, vbExclamation, Extender.Parent.Caption
   Screen.MousePointer = vbDefault

End Sub

Public Sub EditRec()

   If m_RecordSet.RecordCount = 0 Then Err.Raise vbObjectError + 457, Extender.Name, "No available record to edit.": Exit Sub
   RaiseEvent BeforeEdit
   mEditMode = True

   Call LockControlEx(False)

End Sub

Public Sub NewRec()

   RaiseEvent BeforeAdd

   Call ClearControlEx
   Call LockControlEx(False)

   m_RecordSet.AddNew
   mAddMode = True

End Sub

Public Function FindRecord(ByVal FieldToFind, ByVal ValueToFind, _
                           Optional ByVal FieldToFind1, Optional ByVal ValueToFind1, _
                           Optional ByVal FieldToFind2, Optional ByVal ValueToFind2, _
                           Optional ByVal ShowRec As Boolean = True, _
                           Optional ByVal RaiseMoveComplete As Boolean = True) As Boolean
   
   If mAddMode Or mEditMode Then
      Err.Raise vbObjectError + 2542, Extender.Name, "Cannot use FindRecord Function when add/edit mode"
   End If

   On Error GoTo ErrOnEditMode

   Dim i As Integer
   Dim nFieldVal As String
   Dim nFieldVal1 As Variant
   Dim nFieldVal2 As Variant

   Screen.MousePointer = vbArrowHourglass
   With m_RecordSet
      If .RecordCount = 0 Then Screen.MousePointer = vbDefault: Exit Function
      .MoveFirst
      '--------------------------------------------------------------
         'Format ValueToFind according to data type
      If IsDate(ValueToFind) And _
         (.Fields(FieldToFind).Type = adDate Or _
         .Fields(FieldToFind).Type = adDBDate Or _
         .Fields(FieldToFind).Type = adDBTime Or _
         .Fields(FieldToFind).Type = adDBTimeStamp) Then
         
         nFieldVal = "#" & Format$(ValueToFind, "m/d/yyyy") & "#"
         
      ElseIf IsNumeric(ValueToFind) And _
         (.Fields(FieldToFind).Type = adBigInt Or _
         .Fields(FieldToFind).Type = adCurrency Or _
         .Fields(FieldToFind).Type = adDecimal Or _
         .Fields(FieldToFind).Type = adDouble Or _
         .Fields(FieldToFind).Type = adInteger Or _
         .Fields(FieldToFind).Type = adNumeric Or _
         .Fields(FieldToFind).Type = adSingle Or _
         .Fields(FieldToFind).Type = adSmallInt Or _
         .Fields(FieldToFind).Type = adTinyInt Or _
         .Fields(FieldToFind).Type = adUnsignedBigInt Or _
         .Fields(FieldToFind).Type = adUnsignedInt Or _
         .Fields(FieldToFind).Type = adUnsignedSmallInt Or _
         .Fields(FieldToFind).Type = adUnsignedTinyInt Or _
         .Fields(FieldToFind).Type = adVarNumeric) Then  'I'm not so sure if all of this data types are necessary here
                                                         'just to be sure I include them all...
         nFieldVal = ValueToFind
      Else
         nFieldVal = "'" & ValueToFind & "'"
      End If
      'Locate record using find method
Again:
      Call .Find(.Fields(FieldToFind).Name & "=" & nFieldVal)
      
      If ((IsMissing(FieldToFind1) And IsMissing(ValueToFind1)) _
         And (IsMissing(FieldToFind2) And IsMissing(ValueToFind2))) Then

         If Not .EOF Then 'record found
            FindRecord = True
            If ShowRec Then
               Call BindDataToControl
               If RaiseMoveComplete Then _
                  RaiseEvent MoveComplete
            End If
            Screen.MousePointer = vbDefault
            Exit Function
         Else
            FindRecord = False
            Screen.MousePointer = vbDefault
            Exit Function
         End If
         '--------------------------------------------------------------
      Else
         'Multi-column search
         'Hint: Multi-column search is slower than single-column search
         
         If (.Fields(FieldToFind1).Type = adChar) Or _
            (.Fields(FieldToFind1).Type = adVarChar) Or _
            (.Fields(FieldToFind1).Type = adVarWChar) Or _
            (.Fields(FieldToFind1).Type = adLongVarChar) Or _
            (.Fields(FieldToFind1).Type = adLongVarWChar) Or _
            (.Fields(FieldToFind1).Type = adWChar) Then
            nFieldVal1 = Trim$(.Fields(FieldToFind1)) 'trim value for SQL compatibility
         Else
            nFieldVal1 = .Fields(FieldToFind1)
         End If
         '-------------------------------------------------
         If (.Fields(FieldToFind2).Type = adChar) Or _
            (.Fields(FieldToFind2).Type = adVarChar) Or _
            (.Fields(FieldToFind2).Type = adVarWChar) Or _
            (.Fields(FieldToFind2).Type = adLongVarChar) Or _
            (.Fields(FieldToFind2).Type = adLongVarWChar) Or _
            (.Fields(FieldToFind2).Type = adWChar) Then
            nFieldVal2 = Trim$(.Fields(FieldToFind2)) 'trim value for SQL compatibility
         Else
            nFieldVal2 = .Fields(FieldToFind2)
         End If
         '-------------------------------------------------
         On Error GoTo 0
            '-------------------------------------------------
         If Not ((IsMissing(FieldToFind1) And IsMissing(ValueToFind1)) _
            And (IsMissing(FieldToFind2) And IsMissing(ValueToFind2))) Then
            If (LCase(nFieldVal1) = LCase(ValueToFind1) And LCase(nFieldVal2) = LCase(ValueToFind2)) Then
               FindRecord = True
               If ShowRec Then
                  Call BindDataToControl
                  If RaiseMoveComplete Then _
                     RaiseEvent MoveComplete
               End If
               Screen.MousePointer = vbDefault
               Exit Function
            Else
               If Not .EOF Then
                  .MoveNext
                  GoTo Again
               Else
                  FindRecord = False
               End If
            End If
         ElseIf Not (IsMissing(FieldToFind1) And IsMissing(ValueToFind1)) Then
            If LCase(nFieldVal) = LCase(ValueToFind) And LCase(nFieldVal1) = LCase(ValueToFind1) Then
               FindRecord = True
               If ShowRec Then
                  Call BindDataToControl
                  If RaiseMoveComplete Then _
                     RaiseEvent MoveComplete
               End If
               Screen.MousePointer = vbDefault
               Exit Function
            Else
               If Not .EOF Then
                  .MoveNext
                  GoTo Again
               Else
                  FindRecord = False
               End If
            End If
         End If
      End If
   End With
   Screen.MousePointer = vbDefault
   Exit Function
ErrOnEditMode:
   MsgBox Err.Description & vbCrLf & vbCrLf & _
      "If problem persist, please contact Technical Support for more information." _
      , vbCritical, Extender.Parent.Caption
      
   Screen.MousePointer = vbDefault

End Function

Private Sub BindDataToControl()

   On Error GoTo BindErr

   Dim i       As Integer
   Dim Chunk() As Byte

   With m_RecordSet
      For i = 1 To cBoundControl.Count
         If (TypeName(cBoundControl(i)) = "CheckBox" And _
            .Fields(cDataField(i)).Type = adBoolean) Then
            cBoundControl(i) = IIf((CInt(.Fields(cDataField(i))) = -1), 1, 0)
         ElseIf (TypeName(cBoundControl(i)) = "PictureBox" Or _
            TypeName(cBoundControl(i)) = "Image") And _
            (.Fields(cDataField(i)).Type = adLongVarBinary Or _
            .Fields(cDataField(i)).Type = adLongVarWChar Or _
            .Fields(cDataField(i)).Type = adBinary Or _
            .Fields(cDataField(i)).Type = adVarBinary) Then
            On Error Resume Next
            Chunk() = .Fields(cDataField(i)).GetChunk(.Fields(cDataField(i)).ActualSize)
            If Not (Err.Number = 0 Or Err.Number = 13) Then
               Set cBoundControl(i).Picture = Nothing
            Else
               Set cBoundControl(i).Picture = MDLChunk2Image(Chunk())
            End If
            On Error GoTo BindErr
         ElseIf TypeName(cBoundControl(i)) = "ComboBox" Then
            If IsNull(.Fields(cDataField(i))) Or .Fields(cDataField(i)) = "" Then
               cBoundControl(i).ListIndex = -1
            Else
               cBoundControl(i) = .Fields(cDataField(i))
            End If
         Else
            cBoundControl(i) = IIf(IsNull(.Fields(cDataField(i))), "", .Fields(cDataField(i)))
         End If
      Next
   End With
   Exit Sub
BindErr:
   'for developer awareness
   MsgBox Err.Description & vbCrLf & vbCrLf & _
            "Details " & vbCrLf & vbCrLf & _
            "Control Name:     " & cBoundControl(i).Name & vbCrLf & _
            "DataField Index:  " & cDataField(i) _
            , vbExclamation, Extender.Parent.Caption
   Resume Next
End Sub

'Clear all objects enumerated in this procedure.
'DynaTextBox,TextEdit,ComboEdit,ButtonEdit and DateEdit are
'some of the ActiveX controls I developed. They will be published soon...
Private Sub ClearControlEx()

   Dim frmObj As Object

   With mParent
      For Each frmObj In .Controls
         If TypeName(frmObj) = "TextBox" Or _
            TypeName(frmObj) = "DynaTextBox" Or _
            TypeName(frmObj) = "RichTextBox" Or _
            TypeName(frmObj) = "TextEdit" Or _
            TypeName(frmObj) = "ComboEdit" Or _
            TypeName(frmObj) = "ButtonEdit" Or _
            TypeName(frmObj) = "DateEdit" Then
            frmObj.Text = ""
         ElseIf TypeName(frmObj) = "ComboBox" Then
            On Error Resume Next
            frmObj.Text = ""        'expect an error here when combobox style is set to 2
            frmObj.ListIndex = -1
            On Error GoTo 0
         ElseIf (TypeName(frmObj) = "DTPicker") Then
            On Error Resume Next
            frmObj.Value = Null     'expect an error here when checkbox property is set to false
            If Err.Number <> 0 Then
               frmObj.Value = Date
            End If
            On Error GoTo 0
         ElseIf (TypeName(frmObj) = "CheckBox") Then
            frmObj.Value = 0
         ElseIf (TypeName(frmObj) = "OptionButton") Then
            frmObj.Value = False
         ElseIf (TypeName(frmObj) = "Image") Or _
            (TypeName(frmObj) = "PictureBox") Then
            Set frmObj.Picture = Nothing
         ElseIf TypeName(frmObj) = "MaskEdBox" Then
            Dim tmpMsk As String
            If frmObj.Mask <> "" Then
               tmpMsk = frmObj.Mask
               frmObj.Mask = ""
               frmObj.Text = ""
               frmObj.Mask = tmpMsk
            Else
               frmObj.Text = ""
            End If
         End If
      Next
   End With

End Sub


Private Function BindControlToData() As Boolean

   On Error GoTo ErrTrack

   Dim i As Integer

   Dim Chunk() As Byte

   With m_RecordSet
      For i = 1 To cBoundControl.Count
         If TypeName(cBoundControl(i)) = "CheckBox" And _
            .Fields(cDataField(i)).Type = adBoolean Then
            .Fields(cDataField(i)) = CBool(cBoundControl(i))
         ElseIf (TypeName(cBoundControl(i)) = "PictureBox" Or _
            TypeName(cBoundControl(i)) = "Image") And _
            (.Fields(cDataField(i)).Type = adLongVarBinary Or _
            .Fields(cDataField(i)).Type = adLongVarWChar Or _
            .Fields(cDataField(i)).Type = adBinary Or _
            .Fields(cDataField(i)).Type = adVarBinary) Then
            On Error Resume Next
            Chunk() = MDLImage2Chunk(cBoundControl(i).Picture)
            If Err.Number = 0 Then
               .Fields(cDataField(i)).AppendChunk Chunk()
            Else
               .Fields(cDataField(i)) = Null
            End If
         Else
            If Not (IsNull(cBoundControl(i)) Or _
               IsEmpty(cBoundControl(i))) Then _
               .Fields(cDataField(i)) = cBoundControl(i)
         End If
      Next
      BindControlToData = True
   End With
   Exit Function
ErrTrack:
   MsgBox Err.Description, vbExclamation, "Invalid Entry"
   cBoundControl(i).SetFocus
   BindControlToData = False

End Function

'Lock all object you added in the control collection
'But I did not include objects w/o a locked property,
'coz it doesn't look good when its disabled.
'Hint: You are to put a DateTimePicker in a Frame, then lock the frame
Private Sub LockControlEx(IsReadOnly As Boolean)

   Dim cnt1  As Integer
   Dim cnt2  As Integer
   Dim cnt3  As Integer

   For cnt1 = 1 To cBoundControl.Count
      If TypeName(cBoundControl(cnt1)) = "TextBox" Or _
            TypeName(cBoundControl(cnt1)) = "ComboBox" Or _
            TypeName(cBoundControl(cnt1)) = "DynaTextBox" Or _
            TypeName(cBoundControl(cnt1)) = "TextEdit" Or _
            TypeName(cBoundControl(cnt1)) = "ComboEdit" Or _
            TypeName(cBoundControl(cnt1)) = "ButtonEdit" Or _
            TypeName(cBoundControl(cnt1)) = "DateEdit" Or _
            TypeName(cBoundControl(cnt1)) = "RichTextBox" Then
         cBoundControl(cnt1).Locked = IIf(cLockOnEdit(cnt1), True, IsReadOnly)
         cBoundControl(cnt1).TabStop = IIf(cLockOnEdit(cnt1), False, Not IsReadOnly)
         cBoundControl(cnt1).BackColor = IIf((cLockOnEdit(cnt1) Or IsReadOnly), _
                                             m_BackColorReadOnly, m_BackColorEditMode)
      ElseIf TypeName(cBoundControl(cnt1)) = "MaskEdBox" Then
         cBoundControl(cnt1).Enabled = IIf(cLockOnEdit(cnt1), False, Not IsReadOnly)
         cBoundControl(cnt1).TabStop = IIf(cLockOnEdit(cnt1), False, Not IsReadOnly)
         cBoundControl(cnt1).BackColor = IIf((cLockOnEdit(cnt1) Or IsReadOnly), _
                                             m_BackColorReadOnly, m_BackColorEditMode)
      End If
   Next
   If Not cFrameControl.Count = 0 Then
      For cnt2 = 1 To cFrameControl.Count
         cFrameControl(cnt2).Enabled = IIf(cFraLockOnEdit(cnt2), False, Not IsReadOnly)
      Next
   End If
   If Not cExtraControl.Count = 0 Then
      For cnt3 = 1 To cExtraControl.Count
         If TypeName(cExtraControl(cnt3)) = "TextBox" Or _
               TypeName(cExtraControl(cnt3)) = "ComboBox" Or _
               TypeName(cExtraControl(cnt3)) = "DynaTextBox" Or _
               TypeName(cExtraControl(cnt3)) = "TextEdit" Or _
               TypeName(cExtraControl(cnt3)) = "ComboEdit" Or _
               TypeName(cExtraControl(cnt3)) = "ButtonEdit" Or _
               TypeName(cExtraControl(cnt3)) = "DateEdit" Or _
               TypeName(cExtraControl(cnt3)) = "RichTextBox" Then
            cExtraControl(cnt3).Locked = IIf(cExLockOnEdit(cnt3), True, IsReadOnly)
            cExtraControl(cnt3).TabStop = IIf(cExLockOnEdit(cnt3), False, Not IsReadOnly)
            cExtraControl(cnt3).BackColor = IIf((cExLockOnEdit(cnt3) Or IsReadOnly), _
                                                m_BackColorReadOnly, m_BackColorEditMode)
         ElseIf TypeName(cExtraControl(cnt3)) = "MaskEdBox" Then
            cExtraControl(cnt3).Enabled = IIf(cExLockOnEdit(cnt3), False, Not IsReadOnly)
            cExtraControl(cnt3).TabStop = IIf(cExLockOnEdit(cnt3), False, Not IsReadOnly)
            cExtraControl(cnt3).BackColor = IIf((cExLockOnEdit(cnt3) Or IsReadOnly), _
                                                m_BackColorReadOnly, m_BackColorEditMode)
         End If
      Next
   End If

End Sub

Public Sub NoRec()

   Call LockControlEx(True)
   Call ClearControlEx

End Sub

Private Function IsRequiredFilled() As Boolean

   Dim i As Integer

   For i = 1 To cRequired.Count
      If cRequired(i) Then
         If cBoundControl(i) = "" Then
            MsgBox "Field cannot have empty value! Please fill in all required fields to continue.", vbInformation, "Required Field"
            On Error Resume Next
            cBoundControl(i).SetFocus
            IsRequiredFilled = False
            On Error GoTo 0
            Exit Function
         Else
            IsRequiredFilled = True
         End If
      Else
         IsRequiredFilled = True
      End If
   Next

End Function

Public Sub AddBoundControl(ByVal objControl As Object, ByVal DataFieldIndex As Variant, _
                           Optional ByVal LockOnEdit As Boolean = False, _
                           Optional ByVal Required As Boolean = False)

   cBoundControl.Add objControl
   cDataField.Add DataFieldIndex
   cLockOnEdit.Add LockOnEdit
   cRequired.Add Required

End Sub

Public Property Get BackColorReadOnly() As OLE_COLOR

   BackColorReadOnly = m_BackColorReadOnly

End Property

Public Property Let BackColorReadOnly(ByVal New_BackColorReadOnly As OLE_COLOR)

   m_BackColorReadOnly = New_BackColorReadOnly
   PropertyChanged "BackColorReadOnly"

End Property

Public Property Get BackColorEditMode() As OLE_COLOR

   BackColorEditMode = m_BackColorEditMode

End Property

Public Property Let BackColorEditMode(ByVal New_BackColorEditMode As OLE_COLOR)

   m_BackColorEditMode = New_BackColorEditMode
   PropertyChanged "BackColorEditMode"

End Property

'Add Frame to locked object/s inside it
Public Sub AddFrameControl(ByVal oFrame As Object, _
                           Optional ByVal LockOnEdit As Boolean = False)

   cFrameControl.Add oFrame
   If Not TypeName(cFrameControl(cFrameControl.Count)) = "Frame" Then
      Err.Raise vbObjectError + 5763, mParent.Name, "Invalid Frame Control"
   End If
   cFraLockOnEdit.Add LockOnEdit

End Sub

'Add Extra unbound control/s
Public Sub AddExtraControl(ByVal oControl As Object, _
                           Optional ByVal LockOnEdit As Boolean = False)

   cExtraControl.Add oControl
   cExLockOnEdit.Add LockOnEdit

End Sub

