Attribute VB_Name = "mdlIMGDBMaster"
Option Explicit
Private Declare Function OSGetTempPath& Lib "kernel32" Alias "GetTempPathA" (ByVal BufferLength&, ByVal Result$)
Private Declare Function OSGetTempFilename& Lib "kernel32" Alias "GetTempFileNameA" (ByVal FilePath$, ByVal Prefix$, ByVal wUnique&, ByVal TempFileName$)

Private Function TrimNulls(ByVal strIn As String) As String

   Dim intPos As Integer

   intPos = InStr(strIn, vbNullChar)
   If intPos = 0 Then
      TrimNulls = strIn
   Else
      If intPos = 1 Then
         TrimNulls = ""
      Else
         TrimNulls = Left$(strIn, intPos - 1)
      End If
   End If

End Function

Private Function GetTempFile(Optional sPrefix As String = "~", _
                             Optional Ext As String = ".tmp") As String

   Const MAX_RETURN = 3000

   Dim sFilePath As String
   Dim sTempResult As String
   Dim lCharCount As Long
   Dim tFile As String

   sTempResult = Space$(MAX_RETURN)
   lCharCount = OSGetTempPath&(MAX_RETURN, sTempResult)
   sFilePath = Left$(sTempResult, lCharCount)
   sTempResult = Space$(MAX_RETURN)
   lCharCount = OSGetTempFilename&(sFilePath, sPrefix, _
      0, sTempResult)
   tFile = TrimNulls(Left$(sTempResult, lCharCount))
   GetTempFile = Left$(tFile, Len(tFile) - 4) & Ext

End Function

Public Function MDLImage2Chunk(Source As StdPicture) As Variant

   Dim FileName As String
   Dim DataFile As Integer
   Dim FileLength As Long
   Dim Chunk() As Byte

   FileName = GetTempFile()

   Call SavePicture(Source, FileName)

   DataFile = FreeFile
   Open FileName For Binary Access Read As DataFile
   FileLength = LOF(DataFile)
   If FileLength = 0 Then
      Close DataFile
      Err.Raise vbObjectError + 100001, , "Image2Chunk: Image file is empty..."
   Else
      ReDim Chunk(FileLength)
      Get DataFile, , Chunk()
   End If
   Close DataFile
   Kill FileName
   MDLImage2Chunk = Chunk()

End Function

Public Function MDLChunk2Image(Chunk() As Byte) As StdPicture

   Dim FileName As String
   Dim DataFile As Integer

   FileName = GetTempFile()
   DataFile = FreeFile
   Open FileName For Binary Access Write As DataFile
   Put DataFile, , Chunk()
   Close DataFile

   Set MDLChunk2Image = LoadPicture(FileName)

   Kill FileName

End Function

